/*
    Task3 Task
    底盘任务
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "module/chassis.h"
#include "module/config.h"
#include "device/ledi.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Chassis_CMD_t c_cmd;
Chassis_t chassis;
LD_t ld_data;
int chassis_ceshi =0;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_Task3(void *argument)
{
  (void)argument; /* 未使用argument，消除警告 */

  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / TASK3_FREQ;

  osDelay(TASK3_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
  chassis_init(&chassis, &Config_GetRobotParam()->chassis, TASK3_FREQ);

  /* USER CODE INIT END */

  while (1)
  {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
                        /* USER CODE BEGIN */
    if (osMessageQueueGet(task_runtime.msgq.imu.eulr, &chassis.pos088.imu_eulr, NULL, 0)==osOK)
		chassis_ceshi =1;
    if(osMessageQueueGet(task_runtime.msgq.imu.gyro, &chassis.pos088.bmi088.gyro, NULL, 0) ==osOK )
		chassis_ceshi =2 ;
   if( osMessageQueueGet(task_runtime.msgq.dr16_data,&ld_data,NULL,0)==osOK) 
	   chassis_ceshi =3;
    // osMessageQueueGet(task_runtime.msgq.cmd_chassis, &c_cmd, NULL, 0) ;
    // 成功接收到命令，更新底盘命令
    if (osMessageQueueGet(task_runtime.msgq.cmd_chassis, &c_cmd, NULL, 0) == osOK)
    {
		chassis_ceshi =5;
      Chassis_update(&chassis);
    
      Chassis_Control(&chassis, &c_cmd);


    }
    else
{
    // 如果没有收到命令，可以执行一个安全停止的逻辑
    // 或者什么都不做，让底盘保持上一帧的状态（取决于你的设计）
    // 一个安全的选择是让底盘停止
	chassis_ceshi=6;
    Chassis_CMD_t safe_cmd = {.mode = STOP, .Vx = 0, .Vy = 0, .Vw = 0};
    
    Chassis_Control(&chassis, &safe_cmd);

}
 Chassis_Setoutput(&chassis);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
}